#!/usr/bin/perl -w

require HTML::TokeParser;

use strict;

my $route = "54C";
my $daytype = "WEEK";
my $daytype_pretty;
if($daytype eq "WEEK") { $daytype_pretty = "Weekdays"; }
elsif($daytype eq "SATU") { $daytype_pretty = "Saturday"; }
elsif($daytype eq "SUND") { $daytype_pretty = "Sunday"; }
else { $daytype_pretty = "Holidays"; }
my $direction = "Inbound";

open (OUT, ">/home/brian/www/buses/data/${route}-${daytype}-${direction}-stops");
select (OUT);

my $i = 0;

my $j;

my $temp = "";

my $token = "";
my $outrow = 0;

my $prevstop = "";
my $stop;

#my local %stops;
my %stops = ();

while (my $parsein =
     HTML::TokeParser->new("/home/brian/www/buses/data/${route}-${daytype}-${direction}-${i}.html"))
{
    print STDERR "  starting to process file ${route}-${daytype}-${direction}-${i}.html\n";
#     my $token = $parsein->get_tag() or print STDERR ("error -- out of tokens");
#     print STDERR "  test token is $token->[0] \n";

    defined ($token = $parsein->get_tag("th")) or
	print STDERR ("error--out of tokens\n");

    defined ($parsein->get_tag("/tr")) or 
	print STDERR ("error -- unable to find end of header row\n");

#    print STDERR ("found end of header row\n");

    while (defined ($token = $parsein->get_tag) &&
	   lc($token->[0]) eq "tr")                     #Do I need lc() func?
    {
#	print STDERR ("    Inside inner loop\n");
	#Get column 1
#	$parsein->get_trimmed_text("/td");

	$parsein->get_tag("/td");

	#Get column 2
	$temp = $parsein->get_trimmed_text("/td");
	$prevstop = $stop;
	$stop = $temp;

	if (exists ($stops{$stop}))
	{
	    foreach $j (@{$stops{$stop}})
	    {
		if ($j eq $prevstop)
		{
		    goto FOUND;
		}
	    }
	    push (@{$stops{$stop}}, $prevstop);
	  FOUND:
	}
	else
	{
	    $stops{$stop} = (($prevstop eq "") ? [0] : [ 0, $prevstop ]);
	}

	$parsein->get_tag("/td");

#	print STDERR ("    stop was ${temp}\n");

	#Check for anything in Column 3
	if (($parsein->get_trimmed_text("/td")) eq "E")
	{
#	    print STDERR ("    found E\n");
	    
	    $prevstop = $stop = "";

	    # We have a trip

	}
	#We can ignore any other columns

	#Pop everything up to next "</tr>" off of input
	$parsein->get_tag("/tr");
    }

    $i += 100;
}
#     defined ( $ttext = $parsein->get_trimmed_text("/font")) or
# 	$ttext = "error--can't get text 1223c9\n";

#sub print_stop($instop);
sub print_stop
{
    my $stop = $_[0];
    if (!(exists ($stops{ $stop })))
    {
	return;
    }
    if ($stops{ $stop }[0] ne 0)     #If there's a 0 this is our first time
    {
	return;
    }
    shift ( @{$stops{ $stop }});
    
    foreach $i ( @{$stops{ $stop }} )
    {
	print_stop($i);
    }
    print $stop, '|';
    delete ($stops{ $stop });
}

foreach $i (keys(%stops))
{
    print_stop($i);
}

